#include-once

; --- Draw image ---

Func ImageDraw( $fClear = False, $fZoom = False )

	; --- Draw image ---

	Local $hBmpSrc = _GDIPlus_BitmapCreateHBITMAPFromBitmap( $hBitmap )
	_WinAPI_SelectObject( $hSrcDC, $hBmpSrc )

	Local $hDestDC = _WinAPI_CreateCompatibleDC( $hDC )
	Local $hBmpDest = _WinAPI_CreateCompatibleBitmap( $hDC, $iPicWidth, $iPicHeight )
	_WinAPI_SelectObject( $hDestDC, $hBmpDest )

	; Draw image (erases all graphics on top of image)
	_WinAPI_StretchBlt( $hDestDC, $iXDest, $iYDest, $iWidthDest, $iHeightDest, _
	                    $hSrcDC, $iXSrc+$dx, $iYSrc+$dy, $iWidthSrc, $iHeightSrc, $SRCCOPY )
	_WinAPI_DeleteDC( $hDestDC )

	; Always clear the picture control for a transparent image
	;If $fTransparent Then $fClear = True

	; If the image (whether zoomed in or not) doesn't fill out the entire picture control, this command
	; erases the unused parts of the picture.
	If $fClear Then _WinAPI_DeleteObject( GUICtrlSendMsg( $idPicture, $STM_SETIMAGE, 0, 0 ) )
	; The command is not needed if the original (unzoomed) size of the source image is larger than the
	; picture control.
	; If the source image is smaller than the picture control, and you zoom out several times in succession,
	; so that the image becomes smaller and smaller and the unused parts in picture control larger and larger,
	; you have to erase the picture control between each zoom out.
	; If you zoom in so that the image becomes larger and larger, you don't have to erase the picture control
	; between each zoom in (except for the first time).

	_WinAPI_DeleteObject( GUICtrlSendMsg( $idPicture, $STM_SETIMAGE, 0, $hBmpDest ) )
	_WinAPI_DeleteObject( $hBmpDest )
	_WinAPI_DeleteObject( $hBmpSrc )

	; --- Draw graphics on top of image ---

	If BitAND( $fGraphics, 1 ) Then
		If Not $fMoveImage And BitAND( $fGraphics, 30 ) Then     ; 30 = 2 + 4 + 8 + 16 (bit 1 - 4)
			; Frame and grid
			If BitAND( $fGraphics, 2 ) Then
				; Draw frame
				If Not BitAND( $fGraphics, 24 ) Or $nZoom < 7 Then _ ; Only draw frame if grid is not drawn
					DrawFrame()
			EndIf
			If BitAND( $fGraphics, 28 ) Then
				; Draw grid
				If BitAND( $fGraphics, 16 ) Then
					If $nZoom > 7 Then DrawGrid() ; Draw grid without bitmap buffer
					$fGraphics -= 16              ; This flag is cleared, also if $nZoom < 7
				ElseIf $nZoom > 7 Then
					; Draw grid with bitmap buffer
					If BitAND( $fGraphics, 4 ) Then
						DrawGrid( True ) ; Update grid in bitmap buffer
						$fGraphics -= 4  ; This flag is cleared
					EndIf
					If BitAND( $fGraphics, 8 ) Then
						_GDIPlus_GraphicsDrawImageRect( $hGraObj, $hBmpBuf, 0, 0, $iPicWidth, $iPicHeight ) ; Draw grid with bitmap buffer
					EndIf                                                                                 ; This flag is NOT cleared
				EndIf
			EndIf
		EndIf
	EndIf

EndFunc

Func DrawFrame()
	If $iXDest + $iWidthDest + 2 > $iPicWidth And _
	   $iYDest + $iHeightDest + 2 > $iPicHeight Then Return
	_GDIPlus_GraphicsDrawRect( $hGraObj, $iXDest - 1, $iYDest - 1, $iWidthDest + 1, $iHeightDest + 1, $hPenFrameGrid )
EndFunc

Func DrawGrid( $fBmpBuf = False )
	Local $hObject = $fBmpBuf ? $hGraphics : $hGraObj

	; Clear buffer
	If $fBmpBuf Then _
		_GDIPlus_GraphicsClear( $hGraphics, 0x00000000 )

	; Horizontal lines
	Local $y = $iYDest
	For $i = 0 To $iHeightSrc - 1
		_GDIPlus_GraphicsDrawLine( $hObject, $iXDest, $y, $iXDest + $iWidthDest, $y, $hPenFrameGrid )
		$y += $nZoom
	Next
	$y -= 1 ; This will displace the rightmost grid line one pixel to the left
	_GDIPlus_GraphicsDrawLine( $hObject, $iXDest, $y, $iXDest + $iWidthDest, $y, $hPenFrameGrid )

	; Vertical lines
	Local $x = $iXDest
	For $i = 0 To $iWidthSrc - 1
		_GDIPlus_GraphicsDrawLine( $hObject, $x, $iYDest, $x, $iYDest + $iHeightDest, $hPenFrameGrid )
		$x += $nZoom
	Next
	$x -= 1 ; This will displace the bottommost grid line one pixel upwards
	_GDIPlus_GraphicsDrawLine( $hObject, $x, $iYDest, $x, $iYDest + $iHeightDest, $hPenFrameGrid )
EndFunc
